<template>
  <div class="fr-grid-row fr-grid-row--gutters fr-px-2w">
    <div class="fr-col-12">
      <StatsFilters
        :follow-up-type-options="followUpTypeOptions"
        :beneficiaries-cities-options="beneficiariesCitiesOptions"
        :agent-options="agentOptions"
        id-prefix="history"
        @filter="onFilter"
      />
    </div>
    <h2 class="fr-col-12 stats-main-title">
      {{ followUpCountLabel }}
    </h2>
    <div class="fr-tabs">
      <ul
        class="fr-tabs__list"
        :class="{ 'interviews-tab-active': isInterviewsTabActive }"
        role="tablist"
        aria-label="Accompagnements"
      >
        <li role="presentation">
          <button
            id="help-requests-tab"
            class="fr-tabs__tab"
            tabindex="0"
            role="tab"
            aria-selected="true"
            aria-controls="help-requests-panel"
            @click="isInterviewsTabActive = false"
          >
            {{ helpRequestCountLabel }}
          </button>
        </li>
        <li role="presentation">
          <button
            id="interviews-tab"
            class="fr-tabs__tab"
            tabindex="0"
            role="tab"
            aria-selected="false"
            aria-controls="interviews-panel"
            @click="isInterviewsTabActive = true"
          >
            {{ interviewCountLabel }}
            <span>{{ firstInterviewCountLabel }}</span>
          </button>
        </li>
      </ul>

      <div
        id="help-requests-panel"
        class="fr-tabs__panel fr-tabs__panel--selected fr-px-0"
        role="tabpanel"
        aria-labelledby="help-requests-tab"
        tabindex="0"
      >
        <AtomAlert
          v-if="helpRequestCountError"
          :alert-type="AlertType.Error"
          message="Le nombre total de demandes d'aide n'a pas pu être chargé."
        />
        <AtomLoader
          v-if="helpRequestCountPending"
          class="fr-mx-auto"
        />
        <div
          v-else-if="helpRequestCount"
          class="fr-grid-row fr-grid-row--gutters fr-px-2w"
        >
          <div class="fr-col-12 fr-col-lg-6">
            <StatsFollowUpType
              :total-count="helpRequestCount"
              collection="help_requests"
              :filters="helpRequestFilters"
            />
          </div>
          <div
            v-if="isMinistryAgent"
            class="fr-col-12 fr-col-lg-6"
          >
            <StatsFollowUpMinistre
              :total-count="helpRequestCount"
              collection="help_requests"
              :filters="helpRequestFilters"
            />
          </div>
          <div class="fr-col-12 fr-col-sm-6 fr-col-lg-3">
            <StatsFollowUpStatus
              :total-count="helpRequestCount"
              collection="help_requests"
              :filters="helpRequestFilters"
            />
          </div>
          <div class="fr-col-12 fr-col-sm-6 fr-col-lg-3">
            <StatsOrganismesPrescripteurs
              :total-count="helpRequestCount"
              collection="help_requests"
              :filters="helpRequestFilters"
            />
          </div>
          <div class="fr-col-12 fr-col-sm-6">
            <StatsFinancialHelpRequests :filters="helpRequestFilters" />
          </div>
          <div class="fr-col-12 fr-col-sm-6 fr-col-lg-3">
            <StatsOrganismesInstructeurs :filters="helpRequestFilters" />
          </div>
        </div>
      </div>
      <div
        id="interviews-panel"
        class="fr-tabs__panel fr-tabs__panel--selected fr-px-0"
        role="tabpanel"
        aria-labelledby="interviews-tab"
        tabindex="0"
      >
        <AtomAlert
          v-if="interviewCountError"
          :alert-type="AlertType.Error"
          message="Le nombre total de synthèses d'entretien n'a pas pu être chargé."
        />
        <AtomLoader
          v-if="interviewCountPending"
          class="fr-mx-auto"
        />
        <div
          v-else-if="interviewCount"
          class="fr-grid-row fr-grid-row--gutters fr-px-2w"
        >
          <div class="fr-col-12 fr-col-lg-6">
            <StatsFollowUpType
              :total-count="interviewCount"
              collection="follow_ups"
              :filters="interviewFilters"
            />
          </div>
          <div class="fr-col-12 fr-col-lg-6">
            <StatsInterviewType
              :total-count="interviewCount"
              :filters="interviewFilters"
            />
          </div>
          <div
            v-if="isMinistryAgent"
            class="fr-col-12 fr-col-lg-6"
          >
            <StatsFollowUpMinistre
              :total-count="interviewCount"
              collection="follow_ups"
              :filters="interviewFilters"
            />
          </div>
          <div class="fr-col-12 fr-col-sm-6 fr-col-lg-3">
            <StatsFollowUpStatus
              :total-count="interviewCount"
              collection="follow_ups"
              :filters="interviewFilters"
            />
          </div>
          <div class="fr-col-12 fr-col-sm-6 fr-col-lg-3">
            <StatsInterviewsActionsEntreprises
              :total-count="interviewCount"
              :filters="interviewFilters"
            />
          </div>
          <div class="fr-col-12 fr-col-sm-6 fr-col-lg-3">
            <StatsOrganismesPrescripteurs
              :total-count="interviewCount"
              collection="follow_ups"
              :filters="interviewFilters"
            />
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script setup>
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import {
    prepareHelpRequestFilters,
    prepareInterviewFilters
  } from '~/utils/stats'

  const { $getItems } = useNuxtApp()

  const isMinistryAgent = useMinistryAgent()

  defineProps({
    followUpTypeOptions: {
      type: Map,
      default: null
    },
    beneficiariesCitiesOptions: {
      type: Map,
      default: null
    },
    agentOptions: {
      type: Map,
      default: null
    }
  })

  const {
    data: helpRequestCount,
    pending: helpRequestCountPending,
    error: helpRequestCountError,
    refresh: helpRequestCountRefresh
  } = useLazyAsyncData('helpRequestCount', () => loadCount('help_requests'), {
    server: false,
    default: () => 0
  })

  const {
    data: interviewCount,
    pending: interviewCountPending,
    error: interviewCountError,
    refresh: interviewCountRefresh
  } = useLazyAsyncData('interviewCount', () => loadCount('follow_ups'), {
    server: false,
    default: () => 0
  })

  const { data: firstInterviewCount, refresh: firstInterviewCountRefresh } =
    useLazyAsyncData(
      'firstInterviewCount',
      () => loadCount('follow_ups', { first_follow_up: { _eq: true } }),
      {
        server: false,
        default: () => 0
      }
    )

  const filters = ref({})
  const isInterviewsTabActive = ref(false)

  const helpRequestFilters = computed(() =>
    prepareHelpRequestFilters(filters.value)
  )

  const interviewFilters = computed(() =>
    prepareInterviewFilters(filters.value)
  )

  const totalHistoryCount = computed(
    () => helpRequestCount.value + interviewCount.value
  )

  const followUpCountLabel = computed(
    () =>
      `${totalHistoryCount.value} ${
        totalHistoryCount.value > 1 ? 'Accompagnements' : 'Accompagnement'
      }`
  )

  const helpRequestCountLabel = computed(
    () =>
      `${helpRequestCount.value} ${
        helpRequestCount.value > 1 ? "Demandes d'aide" : "Demande d'aide"
      }`
  )

  const interviewCountLabel = computed(
    () =>
      `${interviewCount.value} ${
        interviewCount.value > 1 ? 'Entretiens' : 'Entretien'
      }`
  )

  const firstInterviewCountLabel = computed(
    () =>
      `${firstInterviewCount.value} ${
        firstInterviewCount.value > 1
          ? 'Premiers entretiens'
          : 'Premier entretien'
      }`
  )

  watch(filters, () => {
    helpRequestCountRefresh()
    interviewCountRefresh()
    firstInterviewCountRefresh()
  })

  function onFilter(newFilters) {
    filters.value = newFilters
  }

  async function loadCount(collection, filters = {}) {
    const defaultFilters =
      collection === 'help_requests'
        ? helpRequestFilters.value
        : interviewFilters.value
    // NOTE: It is not using `count` agreggation due to a Directus bug - See https://github.com/directus/directus/discussions/16992
    const res = await $getItems(collection, {
      aggregate: { countDistinct: 'id' },
      filter: {
        ...defaultFilters,
        ...filters
      }
    })

    if (res.status === 200) {
      return parseInt(res.data.data[0].countDistinct.id)
    }
    throw new Error(errorResponseMessage(res))
  }
</script>

<style lang="scss" scoped>
  @use '@gouvfr/dsfr/module/media-query' as dsfr-media-query;

  .fr-tabs {
    box-shadow: none;
  }

  .fr-tabs__list {
    column-gap: 0.5rem;
    border-bottom: 3px solid var(--primary);

    &.interviews-tab-active {
      border-bottom: 3px solid var(--color-interview);
    }
  }

  #help-requests-tab,
  #interviews-tab {
    display: flex;
    flex-direction: column;
    align-items: flex-start;
    justify-content: center;
    padding: 0.5rem 1rem;
    border-radius: 7px 7px 0 0;
    border-bottom: none;

    &[aria-selected='true'] {
      color: #fff;
    }
  }

  #help-requests-tab {
    color: var(--color-help-request);
    background-color: var(--color-help-request-light);

    &:hover {
      background-color: var(--color-help-request-light-hover);
    }

    &[aria-selected='true'] {
      background-color: var(--color-help-request);

      &:hover {
        background-color: var(--color-help-request-hover);
      }
    }
  }

  #interviews-tab {
    color: var(--color-interview);
    background-color: var(--color-interview-light);

    span {
      font-size: 1rem;
    }

    &:hover {
      background-color: var(--color-interview-light-hover);
    }

    &[aria-selected='true'] {
      background-color: var(--color-interview);

      &:hover {
        background-color: var(--color-interview-hover);
      }
    }
  }
</style>
